//  Beispiel 14 "Berechnung von richtigen, nicht reprozierbaren Zufallszahlen"
//  
//  Unter Verwendung der IoT32 Brick Library

#include <all_IoT32.h>

float a = 0.0, b = 3.0, Zeit = 0.0;
long Start = 0, Ende = 0, Groesse = 1;
long statistics[256];

void setup()
{
  IoT_Init(true);
  IoT_TerminalWaitInit(true);      // Auf Terminalverbindung warten, damit nichts verloren geht
  Serial.println("");
  Serial.print(chr(12));
  Serial.println("Welcome to IoT-Brick Random-Number-Generator" + spc(22) + "(c) 2015-2017");
  Serial.println(repeatstr("-", 79));
  Serial.println("");//....1....!....2....!....3....!....4....!....5....!....6....!....7....!....8
  Serial.println("Der Random-Number-Generator berechnet 65.536 richtige Zufallszahlen zwischen");
  Serial.println("0 und 255. Dabei wird die Haeufigkeit, mit der jede der 256 moeglichen Zahlen");
  Serial.println("auftritt, statistisch ausgewertet. Die Berechnung der Zufallszahlen bezieht");
  Serial.println("dabei den Microsekunden-Timer mit ein, wodurch bei jedem Programmstart immer");
  Serial.println("neue, nicht reprozierbare Zufallszahlen entstehen. Statistische Verteilung:");
  Serial.println("");

  for (int i = 0; i <= 255; i++)
  {
    statistics[i] = 0;
  }

  for (long i = 0; i <= 0xFFFF; i++)
  {
    byte r = rndbyte();
    statistics[r] += 1;
    IoT_Idle();
  }

  for (int i = 0; i <= 255; i++)
  {
    Serial.print(hexword(statistics[i]));
    if (i < 255)
    {
      Serial.print(" ");
    }
  }
}

void loop()
{
  IoT_ShutDown();
}

